package riven.classpath.math;

public class Plane extends Vec4 {
	public static Plane fromTri(Vec3 v0, Vec3 v1, Vec3 v2) {
		Vec3 d0 = new Vec3(v1).sub(v0);
		Vec3 d1 = new Vec3(v2).sub(v0);

		Plane p = new Plane();

		// cross product
		p.x = d1.y * d0.z - d1.z * d0.y;
		p.y = d1.z * d0.x - d1.x * d0.z;
		p.z = d1.x * d0.y - d1.y * d0.x;

		// normalize
		float len = (float) Math.sqrt(p.x * p.x + p.y * p.y + p.z * p.z);
		float s = 1.0f / len;
		p.x *= s;
		p.y *= s;
		p.z *= s;

		// calc distance to plane (dot product)
		p.w = -((p.x * v0.x) + (p.y * v0.y) + (p.z * v0.z));

		return p;
	}

	public float side(float x, float y, float z) {
		return this.x * x + this.y * y + this.z * z + this.w;
	}
}
